<?php

namespace go\modules\community\notes\controller;

use go\core\jmap\EntityController;
use go\modules\community\notes\model;


class Note extends EntityController {
	
	/**
	 * The class name of the entity this controller is for.
	 * 
	 * @return string
	 */
	protected function entityClass() {
		return model\Note::class;
	}
	
	public function decrypt($params) {
//		$note = $this->getEntity($params['id']);
		
		$descrypted = \go\core\util\Crypt::decrypt($params['data'], $params['password']);
		
		if(!$descrypted) {
			throw new \Exception("Invalid password");
		}
		
		\go\core\jmap\Response::get()->addResponse([
				'content' => $descrypted
		]);
	}
	
	
	/**
	 * Handles the Foo entity's Foo/query command
	 * 
	 * @param array $params
	 * @see https://jmap.io/spec-core.html#/query
	 */
	public function query($params) {
		return $this->defaultQuery($params);
	}
	
	/**
	 * Handles the Foo entity's Foo/get command
	 * 
	 * @param array $params
	 * @see https://jmap.io/spec-core.html#/get
	 */
	public function get($params) {
		return $this->defaultGet($params);
	}
	
	/**
	 * Handles the Foo entity's Foo/set command
	 * 
	 * @see https://jmap.io/spec-core.html#/set
	 * @param array $params
	 */
	public function set($params) {
		return $this->defaultSet($params);
	}
	
	
	/**
	 * Handles the Foo entity's Foo/changes command
	 * 
	 * @param array $params
	 * @see https://jmap.io/spec-core.html#/changes
	 */
	public function changes($params) {
		return $this->defaultChanges($params);
	}


	/**
	 * @param $params
	 * @return array
	 * @throws \go\core\jmap\exception\InvalidArguments
	 */
	public function export($params) {
		return $this->defaultExport($params);
	}

	
	/**
	 * @param $params
	 * @return array
	 * @throws \Exception
	 */
	public function import($params) {
		return $this->defaultImport($params);
	}


	/**
	 * @param $params
	 * @return array
	 * @throws \Exception
	 */
	public function importCSVMapping($params)
	{
		return $this->defaultImportCSVMapping($params);
	}
}
